/***************************************************************************
 * Sonic Retro Image Recovery Program v0.4                                 *
 *                                                                         *
 * Copyright (c) 2009 by David Korth.                                      *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at your  *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.           *
 ***************************************************************************/

// tchar.h wrapper.

#ifndef __RF_TCHAR_H
#define __RF_TCHAR_H

#ifdef _WIN32

// Win32. #include <tchar.h>
#define WIN32_LEAN_AND_MEAN
#ifndef NOMINMAX
#define NOMINMAX
#endif
#include <windows.h>
#include <tchar.h>

#else

// Not Windows. Map the TCHAR functions.
#define TCHAR char
#define TEXT(x)		x
#define _tprintf	printf
#define _ftprintf	fprintf
#define _sntprintf	snprintf
#define _topendir	opendir
#define _treaddir	readdir
#define _tcscmp		strcmp
#define _tclosedir	closedir
#define _tfopen		fopen
#define _TDIR		DIR
#define _tdirent	dirent
#define _fputtc		fputc
#endif

#ifdef __cplusplus

// C++ strings.
#if defined(_WIN32) && (defined(UNICODE) || defined(_UNICODE))
#define CPPstring std::wstring
#else
#define CPPstring std::string
#endif

#endif

#endif /* __RF_TCHAR_H */
